﻿local mcqi_ui = UI.CreateContext("MCQI UI")
local mcqi_events = UI.CreateFrame("SimpleList","List of the last Extractor Events",mcqi_ui)
local mcqi_kills = UI.CreateFrame("SimpleList","List of the last Recent Kills",mcqi_ui)
local mcqi_extframe = UI.CreateFrame("Frame","Transparent Overlay for Extractors",mcqi_ui)
local mcqi_killframe = UI.CreateFrame("Frame","Transparent Overlay for Extractors",mcqi_ui)
local mcqui_where = UI.CreateFrame("SimpleList","Location of the last events",mcqi_ui)
local mcqui_dom = UI.CreateFrame("SimpleList","Dominion",mcqi_ui)
local mcqui_oath = UI.CreateFrame("SimpleList","Oathsworn",mcqi_ui)
local mcqui_nf = UI.CreateFrame("SimpleList","Nightfall",mcqi_ui)
local mcqi_dom_icon = UI.CreateFrame("Texture","Dom Icon",mcqi_ui)
local mcqi_oath_icon = UI.CreateFrame("Texture","Oath Icon",mcqi_ui)
local mcqi_nf_icon = UI.CreateFrame("Texture","NF Icon",mcqi_ui)

MontsCQInfo = {}

local mcqi_inconquest = false
local mcqi_current = {}
local mcqi_currentkills = {}
local mcqi_updatetime = 0
-- local mcqi_currenttext = {}
-- local mcqi_currentloc = {}

--{coordX = 1877.9399580248, coordY = 1087.5999756902, coordZ = 3069.8499313835, description = "Crown Hill\
--Dominion Extractor\Level 60\NPC 4\Oathsworn 27\", id = "l00000094,800000025F0901DD", title = "Dominion "}

--{coordX = 1813.9499594551, coordY = 1062.0099762622, coordZ = 2337.5999477506, description = "Recent Kills: 3",
-- id = "l0000003A,80000003C208AFD8"}

function MontsCQInfo.Main(a)
	if a == "MontsCQInfo" then
		if not MCQISave then
			MCQISave = {
					ext_x = 100,
					ext_y = 100,
					kill_x = 600,
					kill_y = 600,
					maxevents = 10
			}
		end
		MontsCQInfo.Build()
	end
end

function MontsCQInfo.Build()
	mcqi_extframe:SetVisible(false)
	mcqi_extframe:SetLayer(0)
	mcqi_extframe:SetAlpha(0)
	mcqi_extframe:SetWidth(450)
	mcqi_extframe:SetHeight(100)
	mcqi_extframe:SetPoint("TOPLEFT",mcqi_ui,"TOPLEFT",MCQISave.ext_x,MCQISave.ext_y)
	
	function mcqi_extframe.Event:LeftDown()
		if mcqi_extframe.fixedPos then
			return
		end
		mcqi_extframe.leftDown = true
		local mouse = Inspect.Mouse()
		mcqi_extframe.originalXDiff = mouse.x - mcqi_extframe:GetLeft()
		mcqi_extframe.originalYDiff = mouse.y - mcqi_extframe:GetTop()
		local left, top, right, bottom = mcqi_extframe:GetBounds()
	end
	function mcqi_extframe.Event:LeftUp()
		if mcqi_extframe.fixedPos then
			return
		end
		mcqi_extframe.leftDown = false
	end
	function mcqi_extframe.Event:LeftUpoutside()
		if mcqi_extframe.fixedPos then
			return
		end
		mcqi_extframe.leftDown = false
	end
	function mcqi_extframe.Event:MouseMove(x, y)
		if mcqi_extframe.fixedPos then
			return
		end
		if not mcqi_extframe.leftDown then
			return
		end
		local newX = x - self.originalXDiff
		local newY = y - self.originalYDiff
		mcqi_extframe:SetPoint("TOPLEFT", mpb_ui, "TOPLEFT", newX, newY)
		MCQISave.ext_x = newX
		MCQISave.ext_y = newY
	end

	mcqi_events:SetVisible(false)
	mcqi_events:SetLayer(1)
	mcqi_events:SetBackgroundColor(0,0,0,0.8)
	mcqi_events:SetWidth(150)
	mcqi_events:SetEnabled(false)
	mcqi_events:SetPoint("TOPLEFT",mcqi_extframe,"TOPLEFT",0,0)
	
	mcqui_dom:SetVisible(false)
	mcqui_dom:SetLayer(1)
	mcqui_dom:SetBackgroundColor(0,0,0,0.8)
	mcqui_dom:SetLevelFontColor(1,0,0.8,0.8)
	mcqui_dom:SetWidth(100)
	mcqui_dom:SetEnabled(false)
	mcqui_dom:SetPoint("TOPLEFT",mcqi_extframe,"TOPLEFT",150,0)
	
	mcqui_oath:SetVisible(false)
	mcqui_oath:SetLayer(1)
	mcqui_oath:SetBackgroundColor(0,0,0,0.8)
	mcqui_oath:SetLevelFontColor(1,0.8,0.8,0)
	mcqui_oath:SetWidth(100)
	mcqui_oath:SetEnabled(false)
	mcqui_oath:SetPoint("TOPLEFT",mcqi_extframe,"TOPLEFT",250,0)
	
	mcqui_nf:SetVisible(false)
	mcqui_nf:SetLayer(1)
	mcqui_nf:SetBackgroundColor(0,0,0,0.8)
	mcqui_nf:SetLevelFontColor(1,0.6,0.2,1)
	mcqui_nf:SetWidth(100)
	mcqui_nf:SetEnabled(false)
	mcqui_nf:SetPoint("TOPLEFT",mcqi_extframe,"TOPLEFT",350,0)
	
	mcqi_killframe:SetVisible(false)
	mcqi_killframe:SetLayer(0)
	mcqi_killframe:SetAlpha(0)
	mcqi_killframe:SetWidth(450)
	mcqi_killframe:SetHeight(100)
	mcqi_killframe:SetPoint("TOPLEFT",mcqi_ui,"TOPLEFT",MCQISave.kill_x,MCQISave.kill_y)
	
	function mcqi_killframe.Event:LeftDown()
		if mcqi_killframe.fixedPos then
			return
		end
		mcqi_killframe.leftDown = true
		local mouse = Inspect.Mouse()
		mcqi_killframe.originalXDiff = mouse.x - mcqi_killframe:GetLeft()
		mcqi_killframe.originalYDiff = mouse.y - mcqi_killframe:GetTop()
		local left, top, right, bottom = mcqi_killframe:GetBounds()
	end
	function mcqi_killframe.Event:LeftUp()
		if mcqi_killframe.fixedPos then
			return
		end
		mcqi_killframe.leftDown = false
	end
	function mcqi_killframe.Event:LeftUpoutside()
		if mcqi_killframe.fixedPos then
			return
		end
		mcqi_killframe.leftDown = false
	end
	function mcqi_killframe.Event:MouseMove(x, y)
		if mcqi_killframe.fixedPos then
			return
		end
		if not mcqi_killframe.leftDown then
			return
		end
		local newX = x - self.originalXDiff
		local newY = y - self.originalYDiff
		mcqi_killframe:SetPoint("TOPLEFT", mpb_ui, "TOPLEFT", newX, newY)
		MCQISave.kill_x = newX
		MCQISave.kill_y = newY
	end
		
	mcqi_kills:SetVisible(false)
	mcqi_kills:SetLayer(1)
	mcqi_kills:SetBackgroundColor(0,0,0,0.8)
	mcqi_kills:SetLevelFontColor(1,0.8,0,0)
	mcqi_kills:SetWidth(150)
	mcqi_kills:SetEnabled(false)
	mcqi_kills:SetPoint("TOPLEFT",mcqi_killframe,"TOPLEFT",0,0)
	
	mcqui_where:SetVisible(false)
	mcqui_where:SetLayer(1)
	mcqui_where:SetBackgroundColor(0,0,0,0.8)
	mcqui_where:SetWidth(200)
	mcqui_where:SetEnabled(false)
	mcqui_where:SetPoint("TOPLEFT",mcqi_killframe,"TOPLEFT",150,0)

end

function MontsCQInfo.InConquest()
	if mcqi_updatetime == 0 then
		local mcqi_time = Inspect.Time.Real()
		mcqi_updatetime = mcqi_time
	end
	local mcqi_currtime = Inspect.Time.Real()
	if mcqi_currtime >= mcqi_updatetime+10 then
		mcqi_updatetime = mcqi_currtime
		local mcqi_player = Inspect.Unit.Detail("player")
		if mcqi_player then
			if mcqi_player.zone then
				if mcqi_player.zone == "z0000001A4AF8CD7A" and not mcqi_inconquest then
					mcqi_inconquest = true
					Command.Map.Monitor(true)
					mcqi_events:SetEnabled(true)
					mcqi_events:SetVisible(true)
					mcqui_dom:SetEnabled(true)
					mcqui_dom:SetVisible(true)
					mcqui_oath:SetEnabled(true)
					mcqui_oath:SetVisible(true)
					mcqui_nf:SetEnabled(true)
					mcqui_nf:SetVisible(true)
					mcqi_kills:SetEnabled(true)
					mcqi_kills:SetVisible(true)
					mcqui_where:SetVisible(true)
					mcqi_killframe:SetVisible(true)
					mcqi_extframe:SetVisible(true)
				end
				if mcqi_player.zone ~= "z0000001A4AF8CD7A" then
					mcqi_inconquest = false
					Command.Map.Monitor(false)
					mcqi_events:SetVisible(false)
					mcqui_dom:SetVisible(false)
					mcqi_events:SetEnabled(false)
					mcqui_dom:SetEnabled(false)
					mcqui_oath:SetEnabled(false)
					mcqui_oath:SetVisible(false)
					mcqui_nf:SetEnabled(false)
					mcqui_nf:SetVisible(false)
					mcqi_kills:SetEnabled(false)
					mcqi_kills:SetVisible(false)
					mcqui_where:SetVisible(false)
					mcqi_killframe:SetVisible(false)
					mcqi_extframe:SetVisible(false)
					mcqi_current = {}
					mcqi_currentkills = {}
				end
			end
		end
	end
end

 -- Need to send a temp table to filter through current table as I'm getting doubles from add and change

-- If more than 10 remove the bottom one, shift everything down one and
-- insert the new element at the top
function MontsCQInfo.NewEvent(mcqi_new)
	local mcqi_new = {}
	if mcqi_inconquest then
		for mcqi_id,_ in pairs(mcqi_new) do
			--print(mcqi_id)
			local mcqi_mapinfo = Inspect.Map.Detail(mcqi_id)
			if mcqi_mapinfo then
				table.insert(mcqi_new,mcqi_mapinfo)
			end
		end
		MontsCQInfo.FilterEvents(mcqi_new)
	end
end

-- Look for the id that matches the id of the element changed and update
function MontsCQInfo.EventChange(mcqi_changed)
	local mcqi_change = {}
	if mcqi_inconquest then
		for mcqi_id,_ in pairs(mcqi_changed) do
			local mcqi_mapinfo = Inspect.Map.Detail(mcqi_id)
			if mcqi_mapinfo then
				table.insert(mcqi_change,mcqi_mapinfo)
				break
			end
		end
		MontsCQInfo.FilterEvents(mcqi_change)
	end
end

function MontsCQInfo.EventRemove(mcqi_remove)
	if mcqi_remove then
		for mcqi_id,_ in pairs(mcqi_remove) do
			for i=1,table.maxn(mcqi_current),1 do
				if mcqi_id == mcqi_current[i].id then
					table.remove(mcqi_current,i)
					break
				end
			end
			for j=1,table.maxn(mcqi_currentkills),1 do
				if mcqi_id == mcqi_currentkills[j].id then
					table.remove(mcqi_currentkills,j)
					break
				end
			end
		end
	end
end

function MontsCQInfo.FilterEvents(mcqi_filter)
	if mcqi_inconquest then
		if mcqi_filter then
			for j=1,table.maxn(mcqi_filter),1 do
				-- Handle extractor events
				for i=1,table.maxn(mcqi_current)+1,1 do
					local mcqi_namecheck = string.find(mcqi_filter[j].description,"%c") -- Grabs the first line of the description string, which is the name
					if not mcqi_namecheck then
						mcqi_namecheck = 1
					end
					local mcqi_filterunwanted = string.sub(mcqi_filter[j].description,0,mcqi_namecheck-1)
					if string.find(mcqi_filterunwanted,"Extractor") then
						-- Do nothing, we don't want the <Faction> Extractor map events
					elseif i == MCQISave.maxevents+1 then
						-- Make sure it's not a Recent Kill
						if not string.find(mcqi_filterunwanted,"Recent Kill") then
							-- If mcqi_current is maxevents items and id didn't match then remove the top item and insert new item at end
							table.remove(mcqi_current,1)
							table.insert(mcqi_current,MCQISave.maxevents,mcqi_filter[j])
						end
						--break
					-- If id never matched anything insert it into the table
					elseif i == table.maxn(mcqi_current)+1 then
						-- Make sure it's not a Recent Kill
						if not string.find(mcqi_filterunwanted,"Recent Kill") then
							table.insert(mcqi_current,mcqi_filter[j])
						end
						--break
					-- ids are the same so substitue the new data for that map item
					elseif mcqi_current[i].id == mcqi_filter[j].id then
						table.remove(mcqi_current,i)
						table.insert(mcqi_current,i,mcqi_filter[j])
						break
					end
				end
				-- Handle Recent Kill events
				for k=1,table.maxn(mcqi_currentkills)+1,1 do
					print(table.maxn(mcqi_currentkills))
					if k == MCQISave.maxevents+1 then
						if string.find(mcqi_filter[j].description,"Recent Kill") then
							table.remove(mcqi_currentkills,1)
							table.insert(mcqi_currentkills,MCQISave.maxevents,mcqi_filter[j])
						end
					elseif k == table.maxn(mcqi_currentkills)+1 then
						if string.find(mcqi_filter[j].description,"Recent Kill") then	
							table.insert(mcqi_currentkills,mcqi_filter[j])
						end
					elseif mcqi_currentkills[k].id == mcqi_filter[j].id then
						table.remove(mcqi_currentkills,k)
						table.insert(mcqi_currentkills,k,mcqi_filter[j])
					end
				end
			end
			MontsCQInfo.FillLists()
		end
	end
end

--{coordX = 1877.9399580248, coordY = 1087.5999756902, coordZ = 3069.8499313835, description = "Crown Hill\
--Dominion Extractor\Level 60\NPC 4\Oathsworn 27\", id = "l00000094,800000025F0901DD", title = "Dominion "}

--{coordX = 1813.9499594551, coordY = 1062.0099762622, coordZ = 2337.5999477506, description = "Recent Kills: 3",
-- id = "l0000003A,80000003C208AFD8"}

-- {coordX = 1910.679957293, coordY = 1034.4899768773, coordZ = 2735.2899388615, description = "Contested Extractor\
-- Level 50", id = "l0000008E,80000002B505080C", title = "Contested "}

-- {coordX = 1910.679957293, coordY = 1034.4899768773, coordZ = 2735.2899388615, description = "Dominion Extractor\
-- Level 60", id = "l00000094,80000002B5050245", title = "Dominion "}

-- description is just that
-- title for extractors ownership
-- description has numbers of each
function MontsCQInfo.FillLists()
	local mcqi_desc = {}
	local mcqi_coords = {}
	local mcqi_oath = {}
	local mcqi_dom = {}
	local mcqi_nf = {}
	local mcqi_killer = {}
	local mcqi_coords = {}
	local mcqi_extlevel = {}
	local mcqi_killlevel = {}
	--dump(mcqi_currentkills)
	for j=1,table.maxn(mcqi_currentkills),1 do
		if string.find(mcqi_currentkills[j].description,"Recent Kills") then
			table.insert(mcqi_killer,string.match(mcqi_currentkills[j].description,"%w+ %w+. %d+"))
			local mcqi_x = string.sub(tostring(mcqi_currentkills[j].coordX),1,4)
			local mcqi_y = string.sub(tostring(mcqi_currentkills[j].coordY),1,4)
			local mcqi_z = string.sub(tostring(mcqi_currentkills[j].coordZ),1,4)
			table.insert(mcqi_coords,mcqi_x .. "/" ..mcqi_y.. "/" .. mcqi_z)
			table.insert(mcqi_killlevel,1)
		end
	end
	for i=1,table.maxn(mcqi_current),1 do
		--print(mcqi_current[i].description)
		local mcqi_string = mcqi_current[i].description
		--print(mcqi_string)
		if string.find(mcqi_string,"Extractor") then
			local mcqi_tableostrings = {}
			while string.find(mcqi_string,"%c") do 
				local mcqi_nameend = string.find(mcqi_string,"%c")
				local mcqi_name = string.sub(mcqi_string,0,mcqi_nameend-1)
				table.insert(mcqi_tableostrings,mcqi_name)
				--print("String is :: " .. mcqi_name)
				mcqi_string = string.sub(mcqi_string,mcqi_nameend+1)
			end
			dump(mcqi_tableostrings)
			table.insert(mcqi_desc,mcqi_tableostrings[1]) -- First one is always the name
			table.remove(mcqi_tableostrings,1)
			for j=1,table.maxn(mcqi_tableostrings),1 do
				--print(mcqi_tableostrings[i])
				if mcqi_tableostrings[j] then
					if string.find(mcqi_tableostrings[j],"Extractor") then
						table.remove(mcqi_tableostrings,j)
					elseif string.find(mcqi_tableostrings[j],"Level") then
						table.remove(mcqi_tableostrings,j)
					end
				end
			end
		--	print(table.maxn(mcqi_tableostrings))
			if table.maxn(mcqi_tableostrings) == 0 then
				table.remove(mcqi_desc,table.maxn(mcqi_desc))-- Extractor with no info.
			else
				table.insert(mcqi_extlevel,1)
				for i=1,table.maxn(mcqi_tableostrings),1 do
					if string.find(mcqi_tableostrings[i],"Oathsworn") then
						local oath_num = string.match(mcqi_tableostrings[i],"%d+")
						table.insert(mcqi_oath,oath_num)
						table.remove(mcqi_tableostrings,i)
						break
					end
					if i == table.maxn(mcqi_tableostrings) then
						table.insert(mcqi_oath,"0")
					end
				end
				for i=1,table.maxn(mcqi_tableostrings),1 do
					if string.find(mcqi_tableostrings[i],"Dominion") then
						local dom_num = string.match(mcqi_tableostrings[i],"%d+")
						table.insert(mcqi_dom,dom_num)
						table.remove(mcqi_tableostrings,i)
						break
					end
					if i == table.maxn(mcqi_tableostrings) then
						table.insert(mcqi_dom,"0")
					end
				end
				--print(table.maxn(mcqi_tableostrings))
				if table.maxn(mcqi_tableostrings) == 0 then
					table.insert(mcqi_nf,"0")
				end
				for i=1,table.maxn(mcqi_tableostrings),1 do
					if string.find(mcqi_tableostrings[i],"Nightfall") then
						local nf_num = string.match(mcqi_tableostrings[i],"%d+")
						table.insert(mcqi_nf,nf_num)
						table.remove(mcqi_tableostrings,i)
						break
					end
					if i == table.maxn(mcqi_tableostrings) then
						table.insert(mcqi_nf,"0")
					end
				end
			end
		end
	end
	mcqi_events:SetItems(mcqi_desc,{},mcqi_extlevel)
	mcqui_oath:SetItems(mcqi_oath,{},mcqi_extlevel)
	mcqui_dom:SetItems(mcqi_dom,{},mcqi_extlevel)
	mcqui_nf:SetItems(mcqi_nf,{},mcqi_extlevel)
	mcqi_kills:SetItems(mcqi_killer,{},mcqi_killlevel)
	mcqui_where:SetItems(mcqi_coords,{},mcqi_killlevel)
end

table.insert(Event.Addon.Load.End,{MontsCQInfo.Main,"MontsCQInfo","Addon Loaded"})
table.insert(Event.Map.Add,{MontsCQInfo.NewEvent,"MontsCQInfo","An new map element"})
table.insert(Event.Map.Change,{MontsCQInfo.EventChange,"MontsCQInfo","Something has changed"})
table.insert(Event.Map.Remove,{MontsCQInfo.EventRemove,"MontsCQInfo","Something is no longer there"})
table.insert(Event.System.Update.Begin,{MontsCQInfo.InConquest,"MontsCQInfo","Check to see if in conquest"})